"use strict";
/*
"@types/speakeasy": "^2.0.8",
"speakeasy": "^2.0.0"

// Native
import crypto from "crypto";

// Helper
import { helper } from "./helper";
import { codex } from "./codex.helper";

// Vendor
import * as speakeasy from "speakeasy";

export class guardian extends helper {
  totp_secret() {
    const secret = speakeasy.generateSecret();

    return secret.base32;
  }

  totp(secret: string) {
    const otp = speakeasy.totp({
      secret: secret,
      encoding: "base32",
    });

    return otp;
  }

  _totp_secret() {
    const c = new codex();
    const random = crypto.randomBytes(20);
    const secret = c.base32_encode(random);
    return secret;
  }

  _totp(
    secret: any,
    timeStepSeconds: number = 30,
    codeDigits: number = 6
  ): string {
    // Calculate the current Unix time in seconds
    const currentUnixTime = Math.floor(Date.now() / 1000);

    // Calculate the counter value
    const counter = Math.floor(currentUnixTime / timeStepSeconds);

    // Convert the counter to a binary buffer
    const counterBuffer = Buffer.alloc(8);
    counterBuffer.writeBigInt64BE(BigInt(counter), 0);

    // Calculate the HMAC-SHA1 hash
    const hmac = crypto.createHmac("sha1", secret); //Buffer.from(secret, "base32")
    const hash = hmac.update(counterBuffer).digest();

    // Extract the offset from the last 4 bits
    const offset = hash[hash.length - 1] & 0x0f;

    // Extract the 4-byte binary code starting from the offset
    const binaryCode = hash.readUInt32BE(offset) & 0x7fffffff;

    // Calculate the final OTP by taking modulo 10^codeDigits
    const otp = (binaryCode % Math.pow(10, codeDigits))
      .toString()
      .padStart(codeDigits, "0");

    return otp;
  }
}
*/ 
